﻿Public Class Form1
    Dim intScore As UInteger

    Private Sub gameNext_Click(ByVal sender As System.Object, ByVal e As MouseEventArgs) Handles gameNext.MouseDown
        If username.TextLength = 0 Then
            MsgBox("名前を入力してください。", MsgBoxStyle.Critical, "正しく入力されていません")
            Return
        End If

        topmenu.Visible = True
        start.Visible = False
        RefreshRanking()
    End Sub

    Private Sub back_Click(ByVal sender As System.Object, ByVal e As MouseEventArgs) Handles back.MouseDown
        start.Visible = True
        topmenu.Visible = False
    End Sub

    Private Sub gamePanelIni()
        intScore = 0
        scoreLabel.Text = "0点"
        TimeBar.Value = TimeBar.Maximum
        timeLabel.Text = "残り30秒"
        prolong = False
    End Sub

    Dim prolong As Boolean = False
    Private Sub TimeBar_MouseClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TimeBar.MouseClick
        If Not prolong Then
            prolong = True
            Dim i = TimeBar.Value
            i += 5
            If 30 < i Then
                i = 30
            End If
            TimeBar.Value = i
        End If
    End Sub

    Private Sub PictureBox1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles mato.MouseDown
        intScore += 1
        scoreLabel.Text = intScore.ToString("0点")
        hit.PlaySync()
        RandomPoint()
        gameBack.PlayLooping()
    End Sub

    Private Sub gamePanel_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles gamePanel.MouseDown
        boo.PlaySync()
        RandomPoint()
        gameBack.PlayLooping()
    End Sub

    Private Sub gameStart_Click(ByVal sender As System.Object, ByVal e As MouseEventArgs) Handles gameStartBtn.MouseDown
        gamePanel.Visible = True
        topmenu.Visible = False
        GameStart()
    End Sub

    Private Sub GameStart()
        RandomPoint()
        Timer1.Start()
        gameBack.PlayLooping()
    End Sub

    Dim randomer As New Random
    Private Sub RandomPoint()
        Dim p As Point
        p.X = randomer.Next(gamePanel.ClientSize.Width - mato.Width)
        p.Y = randomer.Next(31, gamePanel.ClientSize.Height - (exitBtn.Height + mato.Height))
        mato.Location = p
    End Sub

    Private Sub exitBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles exitBtn.Click
        Timer1.Stop()
        gameBack.Stop()
        topmenu.Visible = True
        gamePanel.Visible = False
        gamePanelIni()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        TimeBar.Value -= 1
        timeLabel.Text = TimeBar.Value.ToString("残り0秒")
        Application.DoEvents()
        If TimeBar.Value = 0 Then
            Timer1.Stop()
            endLabel.Visible = True
            Application.DoEvents()
            btnClick.PlaySync()
            Dim nowkekka = New Result With {.User = username.Text, .Score = intScore, .Prolong = prolong}
            Dim userRanking = Ranking.Instance.UsersRanking(username.Text)
            If userRanking(9).Score <= nowkekka.Score Then
                userRanking(9) = nowkekka
                userRanking.Sort()
            End If
            If Ranking.Instance.PublicRanking(9).Score <= nowkekka.Score Then
                Ranking.Instance.PublicRanking(9) = nowkekka
                Ranking.Instance.PublicRanking.Sort()
            End If
            RefreshRanking()
            Ranking.Save()
            rankingPanel.Visible = True
            gamePanel.Visible = False
            endLabel.Visible = False
            gamePanelIni()
        End If
    End Sub

    Private Sub backtomenuFromRanking_Click(ByVal sender As System.Object, ByVal e As MouseEventArgs) Handles backtomenuFromRanking.MouseDown
        topmenu.Visible = True
        rankingPanel.Visible = False
    End Sub

    Private Sub rankingBtn_Click(ByVal sender As System.Object, ByVal e As MouseEventArgs) Handles rankingBtn.MouseDown
        rankingPanel.Visible = True
        topmenu.Visible = False
    End Sub

    Private Sub RefreshRanking()
        'ユーザーデータ
        If Not Ranking.Instance.UsersRanking.ContainsKey(username.Text) Then
            Ranking.Instance.UsersRanking.Add(username.Text, Ranking.GetDefaultRanking(username.Text))
        End If
        For i = 0 To 9
            TableLayoutPanel1.Controls("scoreUser" & CStr(i + 1)).Text = Ranking.Instance.UsersRanking(username.Text)(i).Score.ToString("0点")
        Next
        'パブリックデータ
        For i = 0 To 9
            Dim r = Ranking.Instance.PublicRanking(i)
            Dim cs = TableLayoutPanel2.Controls
            cs("userPublic" & CStr(i + 1)).Text = r.User
            cs("scorePublic" & CStr(i + 1)).Text = r.Score.ToString("0点")
        Next
    End Sub
End Class
