﻿Public Class gButton
    Inherits Button

    Private Sub evPaint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.DrawImage(My.Resources.button, e.ClipRectangle)

        'ボタンのTextを描画する準備
        Dim sf As New StringFormat
        '文字列を真ん中に描画
        sf.Alignment = StringAlignment.Center
        sf.LineAlignment = StringAlignment.Center
        '&がアンダーラインになるようにする
        sf.HotkeyPrefix = System.Drawing.Text.HotkeyPrefix.Show
        'Brushの作成
        Dim brsh = New SolidBrush(Me.ForeColor)
        '文字列を描画
        e.Graphics.DrawString(Me.Text, Me.Font, brsh, _
            RectangleF.op_Implicit(Me.ClientRectangle), sf)
        brsh.Dispose()
    End Sub

    Protected Overrides Sub OnMouseDown(ByVal mevent As System.Windows.Forms.MouseEventArgs)
        If mevent.Button = Windows.Forms.MouseButtons.Left Then
            Dim old = Text
            Text = "Clicked"
            Me.Refresh()
            btnClick.PlaySync()
            MyBase.OnMouseDown(mevent)
            Text = old
            Me.Invalidate()
        End If
    End Sub

    Public Sub New()
        MyBase.New()
        Size = New Size(200, 40)
        ForeColor = Color.White
        Font = New System.Drawing.Font("MS UI Gothic", 18.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(128, Byte))
        Cursor = Cursors.Hand
    End Sub
End Class
